##### Activity 
# Collaborative Algorithm Design

### Learning Objectives:
- [LO 2.2.1] Develop an abstraction when writing a program or creating other computational artifacts. [P2]
- [LO 2.2.2] Use multiple levels of abstraction to write programs. [P3]
- [LO 2.2.3] Identify multiple levels of abstractions that are used when writing programs. [P3]
- [LO 4.1.1] Develop an algorithm for implementation in a program. [P2]
- [LO 4.1.2] Express an algorithm in a language. [P5]
- [LO 5.1.2] Develop a correct program to solve problems. [P2]
- [LO 5.1.3] Collaborate to develop a program. [P6]

**What is Pair Design and Programming?**

Throughout this unit, students will learn about algorithms through a mix of discussion, exploration, and basic programming. At the end of the unit, the students will put their knowledge of algorithms and programming to use in order to complete the level Wakka Maul in the Introduction to Computer Science or Power Peak in the Computer Science 2 courses on CodeCombat. In their collaboration, the students will work together to create algorithms, execute them in code, and analyze them.

**What you need:**
* Computers with access to CodeCombat. Each student pair should have one computer.

Have the students navigate to the Wakka Maul level in CodeCombat’s Introduction to Computer Science or the Power Peak level in Computer Science 2 course. Students will examine the level individually then take about five minutes to develop an abstraction for a program that can solve the level. Their abstraction can include a structure diagram or simply a general description of what their program will do.

Once the students have completed their abstractions, place them into groups of two. Give the students ten minutes to share their abstraction with their partner then write algorithms for both abstractions using either natural language or pseudocode. Circle around while the partner groups are working and encourage them to discuss their abstractions and algorithms out loud if necessary.

Next, have each partner group implement both algorithms in code and analyze them. Their analysis should include which algorithm worked better and why. Each partner group will then work together to create additional algorithms to implement and analyze. Encourage them to rethink their original abstractions and algorithms to find an ideal solution.

Finally, have each partner group submit a report describing the abstractions and algorithms they developed and their analysis of them.


### Discussion Questions:
- How did you break up the problem into smaller, more manageable pieces?
- How did your abstraction for the program differ from your partner’s?
- How did you determine an algorithm for this level?
- How did your algorithm compare to your partner’s?
- Did you find it easier or harder to collaborate to develop an algorithm? Why?
- Which algorithm was the best? Which was the worst? Why? 
- What are the multiple levels of abstraction that can be used in this program?
